﻿package com.actionsnippet.qbox{
	
	import flash.display.*
	import flash.events.*;
	import Box2D.Dynamics.*;
	import Box2D.Collision.*;
	import Box2D.Collision.Shapes.*;
	import Box2D.Common.Math.*;
	import Box2D.Dynamics.Joints.*;
	
	public class JointObject extends QuickObject {
				   
		public function JointObject(qbox:QuickBox2D, params:Object){
			super(qbox, params);
		}
		
		override protected function defaultParams(p:Object):void{
			p.a = null;
			p.b = null;
			//p.vecA = new b2Vec2(0, 0);
			//p.vecB = new b2Vec2(1, 1);
			p.collideConnected = true;
		}
		
		protected override function build():void{
			var p:Object = params;
			
			if (p.a == null || p.b == null){
				throw new Error("your joint must have b2Body instances for its a and b properties")
			}
			if (p.vecA == null){
				p.vecA = new b2Vec2(p.x1, p.y1);
			}
			if (p.vecB == null){
				p.vecB = new b2Vec2(p.x2, p.y2);
			}
			
			
			 joint= new b2DistanceJointDef();
			 joint.Initialize(p.a, p.b, p.vecA, p.vecB);
			 joint.collideConnected = p.collideConnected;
			 w.CreateJoint(joint);
		}
	}
}